/*
************************************************
**
**	Par Yellow.fr <Yellow.fr AT gmail DOT com>
**
**	Un mail ca cot rien, alors si vous utilis/amlior/optimis, prvenez.
**
**	Post-Sciptum : Navr il y a pas de commentaire j'ai cod ca pour moi.
**
************************************************
*/

function	map()
{
	this.create = function ()
	{
		this.eData = false;
		this.eMsg = false;
		this.eContainer = false;
		
		this.oWorld = false;
		
		this.pxCellLen = 40;

		this.cellVisuLenX = 10;
		this.cellVisuLenY = 10;
		
		this.pxVisuLenX = this.pxCellLen * this.cellVisuLenX;
		this.pxVisuLenY = this.pxCellLen * this.cellVisuLenY;
		
		
		this.cellBuffLenX = this.cellVisuLenX * 3;
		this.cellBuffLenY = this.cellVisuLenY * 3;
		
		this.pxBuffLenX = this.pxCellLen * this.cellBuffLenX;
		this.pxBuffLenY = this.pxCellLen * this.cellBuffLenY;

		this.aCell = Array();

		this.cellOffWorldX = 10;
		this.cellOffWorldY = 10;

		this.pxOffX = 0;
		this.pxOffY = 0;

		this.pxMoveX = 0;
		this.pxMoveY = 0;

		this.isOk = false;
	
		this.pxDragStartX = 0;
		this.pxDragStartY = 0;
		
		this.onCellClick = function () {};
		this.onCellDblClick = function () {};
		this.onCellOver = function () {};
		this.onCellOut = function () {};
	};

/*
************************************************
**
************************************************
*/

	this.init = function (eMap)
	{
		var	self = this;
		
		this.eData = document.createElement('DIV');
		this.eData.style.display = 'none';	
		this.eData.style.position = 'absolute';
		this.eData.style.width = this.pxBuffLenX + 'px';
		this.eData.style.height = this.pxBuffLenY + 'px';
		this.eData.style.left = '-' + this.pxVisuLenX + 'px';
		this.eData.style.top = '-' + this.pxVisuLenY + 'px';
		
		this.eMsg = document.createElement('DIV');
		this.eMsg.style.position = 'absolute';
		this.eMsg.style.top = '180px';
		this.eMsg.style.left = '160px';
		this.eMsg.innerHTML = 'Initialisation...';
		
		if (!eMap) { eMap = document.createElement('DIV'); document.body.appendChild(eMap); }
		if (!eMap.id)
			eMap.id = 'map';

		this.eContainer = eMap;
		this.eContainer.style.position = 'relative';
		this.eContainer.style.overflow = 'hidden';
		this.eContainer.style.width = this.pxVisuLenX + 'px';
		this.eContainer.style.height = this.pxVisuLenX + 'px';
		this.eContainer.style.border = '1px solid #000';
		
		this.eContainer.appendChild(this.eMsg);
		
		eMap.oMap = this;
		
		for (var cellY = 0; cellY < this.cellBuffLenY; cellY++)
			for (var cellX = 0; cellX < this.cellBuffLenX; cellX++)
			{
				var newCell = document.createElement('DIV');
				newCell.className = 'cell';

				newCell.cellX = cellX;
				newCell.cellY = cellY;

				newCell.onclick = this.onCellClick;
				newCell.ondblclick = this.onCellDblClick;
				newCell.onmouseover = this.onCellOver;
				newCell.onmouseout = this.onCellOut;

				this.eData.appendChild(newCell);
			}
		this.aCell = this.eData.getElementsByTagName('DIV');

		this.eContainer.appendChild(this.eData);
		this.eContainer.onmousedown = function (e) { this.oMap.dragStart(e); };
		this.eMsg.innerHTML = 'Initialisation termin.';
	};

/*
************************************************
**
************************************************
*/

	this.update = function ()
	{
		if (!this.isOk) return;
		this.isOk = false;

		this.aCell = this.eData.getElementsByTagName('DIV');
		for (var i=0; i < this.aCell.length; i++) 
		{
			var addr = (this.aCell[i].cellX - this.cellOffWorldX) + '_' + (this.aCell[i].cellY - this.cellOffWorldY);
	
			if (this.oWorld.aCell[addr])
			{
				this.aCell[i].className = 'cell' + this.oWorld.aCell[addr];
				this.aCell[i].myType = this.oWorld.aCell[addr];
			}
			else
				this.aCell[i].className = 'cell';
		}

		this.isOk = true;
	};

/*
************************************************
**
************************************************
*/

	this.loadWorld = function (oWorld)
	{
		var	self = this;
		
		this.oWorld = oWorld;
		this.eMsg.innerHTML = 'Chargement du monde...';
		this.oWorld.onInit = function ()
		{
			
				self.isOk = true;
				self.update();

				self.eData.style.display = 'block';
				self.eMsg.style.display = 'none';
				self.eMsg.innerHTML = 'Monde charg...';
		};
		this.oWorld.init();
	}

/*
************************************************
**
************************************************
*/

	this.dragStart = function (e)
	{

		if (!this.isOk) return;
		this.isOk = false;

		if (document.all) e = event; // I.E.

		var	self = this;
		
		this.pxDragStartX = e.clientX;
		this.pxDragStartY = e.clientY;

		this.pxMoveX = 0;
		this.pxMoveX = 0;
		
		document.body.onmouseup = function () { document.getElementById(self.eContainer.id).oMap.dragStop(); };
		this.eContainer.onmousemove = function (e) { this.oMap.dragMove(e); };
		
		this.isOk = true;
	};
	
/*
************************************************
**
************************************************
*/

	this.dragMove = function (e)
	{
		if (!this.isOk) return;
		this.isOk = false;
		if (document.all) e = event; //  I.E.

		this.pxMoveX = (this.pxOffX + e.clientX - this.pxDragStartX);
		this.pxMoveY = (this.pxOffY + e.clientY - this.pxDragStartY);
		
		this.eData.style.left =  (this.pxMoveX - 400) + 'px';
		this.eData.style.top = (this.pxMoveY - 400) + 'px';

		this.isOk = true;
	};

/*
************************************************
**
************************************************
*/

	this.dragStop = function ()
	{
		if (!this.isOk) return;

		document.body.onmouseup = null;
		this.eContainer.onmousemove = null;
		
		this.isOk = false;

		var	cellMoveX = ((this.pxMoveX < 0) ? (-Math.floor(this.pxMoveX / -40)) : (Math.floor(this.pxMoveX / 40)));
		var	cellMoveY = ((this.pxMoveY < 0) ? (-Math.floor(this.pxMoveY / -40)) : (Math.floor(this.pxMoveY / 40)));


		this.pxOffX = (this.pxMoveX != 0) ? (this.pxMoveX - (cellMoveX * 40)) : (this.pxOffX);
		this.pxOffY = (this.pxMoveY != 0) ? (this.pxMoveY - (cellMoveY * 40)) : (this.pxOffY);
	
		this.eData.style.left = (this.pxOffX - 400) + 'px';
		this.eData.style.top = (this.pxOffY - 400) + 'px';
	
		this.cellOffWorldX += cellMoveX;
		this.cellOffWorldY += cellMoveY;

		this.isOk = true;

		if (this.pxMoveX != 0 && this.pxMoveY != 0)
			this.update();
	};

/*
************************************************
**
************************************************
*/
	this.create();
}